from __future__ import annotations
from dataclasses import dataclass, field
from kiota_abstractions.serialization import AdditionalDataHolder, Parsable, ParseNode, SerializationWriter
from kiota_abstractions.store import BackedModel, BackingStore, BackingStoreFactorySingleton
from typing import Any, Callable, Dict, List, Optional, TYPE_CHECKING, Union

if TYPE_CHECKING:
    from ........models.json import Json

@dataclass
class MatchPostRequestBody(AdditionalDataHolder, BackedModel, Parsable):
    # Stores model information.
    backing_store: BackingStore = field(default_factory=BackingStoreFactorySingleton(backing_store_factory=None).backing_store_factory.create_backing_store, repr=False)

    # Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
    additional_data: Dict[str, Any] = field(default_factory=dict)
    # The lookupArray property
    lookup_array: Optional[Json] = None
    # The lookupValue property
    lookup_value: Optional[Json] = None
    # The matchType property
    match_type: Optional[Json] = None
    
    @staticmethod
    def create_from_discriminator_value(parse_node: ParseNode) -> MatchPostRequestBody:
        """
        Creates a new instance of the appropriate class based on discriminator value
        param parse_node: The parse node to use to read the discriminator value and create the object
        Returns: MatchPostRequestBody
        """
        if not parse_node:
            raise TypeError("parse_node cannot be null.")
        return MatchPostRequestBody()
    
    def get_field_deserializers(self,) -> Dict[str, Callable[[ParseNode], None]]:
        """
        The deserialization information for the current model
        Returns: Dict[str, Callable[[ParseNode], None]]
        """
        from ........models.json import Json

        from ........models.json import Json

        fields: Dict[str, Callable[[Any], None]] = {
            "lookupArray": lambda n : setattr(self, 'lookup_array', n.get_object_value(Json)),
            "lookupValue": lambda n : setattr(self, 'lookup_value', n.get_object_value(Json)),
            "matchType": lambda n : setattr(self, 'match_type', n.get_object_value(Json)),
        }
        return fields
    
    def serialize(self,writer: SerializationWriter) -> None:
        """
        Serializes information the current object
        param writer: Serialization writer to use to serialize this model
        Returns: None
        """
        if not writer:
            raise TypeError("writer cannot be null.")
        writer.write_object_value("lookupArray", self.lookup_array)
        writer.write_object_value("lookupValue", self.lookup_value)
        writer.write_object_value("matchType", self.match_type)
        writer.write_additional_data_value(self.additional_data)
    

